
;-------------------------------------------------------------------------------

Function particle_create(entity, VX#, VY#, VZ#)
	O.Particle = New Particle
	
	O\entity = entity
	O\VX     = VX
	O\VY     = VY
	O\VZ     = VZ
	O\DP     = Rand(-25, 25)
	O\DY     = Rand(-25, 25)
	O\DR     = 0

	TFormVector O\VX, O\VY, O\VZ, 0, entity
	O\VX = TFormedX()
	O\VY = TFormedY()
	O\VZ = TFormedZ()
	
	EntityType     O\entity, COLLISION_PARTICLE
	EntityRadius   O\entity, 1
End Function

Function particle_delete()
	For O.Particle = Each Particle
		Delete O
	Next
End Function

Function particle_update()
	DT# = 1.0 / 30.0
	
	For O.Particle = Each Particle
		If CountCollisions(O\entity) > 0 Then
			O\VX = 0
			O\VY = 0
			O\VZ = 0
			O\DP = 0
			O\DY = 0
			O\DR = 0
		Else
			TFormVector 0, -9.8 * DT, 0, 0, O\entity
			
			MoveEntity O\entity, O\VX * DT, O\VY * DT, O\VZ * DT	
			TurnEntity O\entity, O\DP * DT, O\DY * DT, O\DR * DT
	
			O\VX = O\VX + TFormedX()
			O\VY = O\VY + TFormedY()
			O\VZ = O\VZ + TFormedZ()
		End If
	Next
End Function

;-------------------------------------------------------------------------------